-------
v4.2.29
-------

[mjr] Fix regression in accessing virtual address books.


-------
v4.2.28
-------

[mjr] Fix regressions in configuring address book sources.


-------
v4.2.27
-------

[jan] Fix method call when removing user data.


-------
v4.2.26
-------

[jan] SECURITY: Fix remote code execution by an unserialization attack
      (CVE-2022-30287).
[jan] Fix deprecation warnings about each() with PHP 7.2+.
[mjr] Fix setting LDAP_OPT_REFERRALS to 0.
[jan] Fix exporting contacts to LDIF (Bug #14934).


-------
v4.2.25
-------

[mjr] Fix typo that could cause tags to be lost during EAS sync, if the
      categories property is ghosted.


-------
v4.2.24
-------

[mjr] SECURITY: Fix XSS vulnerability in display of contact tags.
[jan] Clarify objectClass filter examples for LDAP backends (Ralf Lang
      <lang@b1-systems.de>, PR 3).


-------
v4.2.23
-------

[mjr] Remove debug output that was breaking EAS searches (Bug: 14843).


-------
v4.2.22
-------

[jan] Allow to use table prefixes in SQL column map.
[jan] Fix reading LDAP contacts if 'objectclass' parameter is empty.
[mjr] Fix filtering Turba_Api::search() results by requested fields (Bug
      #14719).
[mjr] Ensure new contacts from EAS clients are given a name attribute.


-------
v4.2.21
-------

[jan] Officially support PHP 7.


-------
v4.2.20
-------

[jan] SECURITY: Fix open redirects.
[jan] Fix creating address books with the external API.


-------
v4.2.19
-------

[mjr] Fix importing vCard LABEL fields (Bug #14584).
[mjr] Fix saving sync preference when no default address book exists (Bug
      #14585).
[mjr] Fix removing virtual address books when calling the removeUserData API
      (Bug #14577).
[jan] Fix fatal error if group contacts from an LDAP server don't exist
      anymore.


-------
v4.2.18
-------

[jan] Remove left over from 10-years-old code (Bug #14521).


-------
v4.2.17
-------

[mjr] Fix regression in sorting contacts by a name field (Bug #14471).
[mjr] Fix regression in saving tags (Bug #14463).


-------
v4.2.16
-------

[mjr] Fix synchronizing email fields in certain cases (Bug #14301).
[jan] Continue removing user data if a source doesn't have an __owner field.
[mjr] Fix over-agressive filtering of search results when searching via the API
      (Bug #13945).


-------
v4.2.15
-------

[jan] Update Portuguese translation.
[jan] Update Basque translation.
[mjr] Fix searching via the API when specifying fields and not specifying
      source.
[mjr] Require Horde_Perms::DELETE for including an address book  as sync-able.


-------
v4.2.14
-------

[mjr] Fix persisting tags when moving or copying a contact to another address
      book (Bug #14312).
[mjr] Fix resetting state when changing sync_book prefs and device has forced
      multiplex.
[mjr] Fix synchronizing contact notes via ActiveSync when no truncation value
      is requested by the client (Bug #14307).


-------
v4.2.13
-------

[mjr] Honor alternative_name mapping (Bug #14280).
[mjr] Fix dealing with orphaned virtual address books.
[jan] Update Greek translation (Limperis Antonis <limperis@cti.gr>).


-------
v4.2.12
-------

[jan] Fix building search query if some fields are set for strict search (Bug
      #12272).
[jan] Use access rules compatible with both Apache 2.2 and 2.4.
[mjr] Fix splitting tags over ActiveSync (Bug #14218).
[mjr] Fix searching within virtual address books (Bug #14155).
[mjr] Fix import of vCard with single component via API.


-------
v4.2.11
-------

[mjr] Fix regression in removing all contacts from a single address book in the
      Sql driver (Bug #14145, Guenter Bartsch
      <guenter.bartsch@vista-rasch.com>).


-------
v4.2.10
-------

[mjr] Fix fatal test error related to Content_Tagger.


------
v4.2.9
------

[mjr] Better prevention of importing duplicate contacts with same email
      addresses via the API (Bug #14119).
[mjr] Remove object reference from Content when object is deleted (Bug #14112).
[mjr] Remove tags from Content when tagged object is deleted (Bug #14112).
[mjr] Allow API to search all email type fields when calling getField().
[mjr] Fix removing all contacts owned by a specific user.
[jan] Fix inserting and updating photos with Oracle backends.
[mjr] Fix incorrectly populating email field when importing vCard (Bug #14046).


------
v4.2.8
------

[mjr] Fix issue where sidebar links point to incorrect address book.


------
v4.2.7
------

[jan] Fix error when removing user data.


------
v4.2.6
------

[jan] Don't try to load Content application if tags are disabled.
[mjr] Fix adding tags to new contacts (Bug #13884).
[jan] Fix waiting for replication on LDAP backend.


------
v4.2.5
------

[jan] Fix export format of tags to vCard 3.0 categories (Bug #13800).


------
v4.2.4
------

[jan] Use the SHOW permission to determine the sidebar address book list.


------
v4.2.3
------

[jan] Export nicer display names for users and resources via WebDAV.
[jan] Export custom owner and read-only properties via WebDAV.
[jan] Fix exporting contacts without __uid attributes via WebDAV.
[jan] Fix importing empty birthdays/anniversaries from vCard.
[mjr] Fix defaulting to the defined search fields when searching via the API.
[mjr] Fix broken EAS synchronization due to incorrect setting of the
      Categories field.


------
v4.2.2
------

[jan] Fix duplicate searching in address books without owner field.
[jan] Fix duplicate search form (woe@gmx.de, Bug #13528).
[mms] Make case-insensitive API e-mail search work on non-ASCII data (Request
      #12480).
[jan] Fix listing group members that contain colons in their IDs.


------
v4.2.1
------

[jan] Display correct address books in WebDAV folders.
[jan] Fix displayed CardDAV URLs for shared address books (Bug #12380).
[mms] Only include e-mail addresses that match the search string in the return
      from the search() API call (Request #12480).
[mjr] Fix exporting tags via vCard and ActiveSync (Bug #13393).
[mjr] Add EAS client created shares to the sync_books preference (Bug #13359).
[mjr] Add missing API support for searchTags API (Bug #13362).
[mjr] Fix issue that caused contacts to be tagged with a broken username.


------
v4.2.0
------

[jan] Fix fatal error if importing CSV data with date fields.


---------
v4.2.0RC2
---------

[mjr] Fix another regression with exporting photos in vCard when we are
      ignoring empty values.


---------
v4.2.0RC1
---------

[mjr] Fix regression with exporting photos in vCard when we are ignoring empty
      values.
[jan] Update Polish translation (Maciej Uhlig <maciej.uhlig@us.edu.pl>).
[jan] Update Japanese translation (Hiromi Kimura <hiromi@tac.tsukuba.ac.jp>).


-----------
v4.2.0beta1
-----------

[jan] Export composite attributes to vCard too.


------------
v4.2.0alpha1
------------

[jan] Don't export binary fields to CSV/TSV.
[mms] Fix search in Facebook driver.
[jan] Add script to import contacts from Open-Xchange.
[jan] Don't remove missing contacts from distributions lists in Kolab backends
      (Bug #12861).
[jan] Support binary fields (photos) in Kolab backends.
[mjr] Fix importing certain vCards to sources only using the 'email' attribute
      (Bug #12955).
[jan] Make shares table compatible with Oracle.
[jan] Export free/busy URL to vCard (Request #12915).
[mjr] Fix listTimeObjects API when format_in attribute parameter is changed
      from default (Bug #11891).
[mjr] Add API support for supporting multiple addressbooks via ActiveSync.
[jan] Remember currently open tab when switching or saving contact views
      (Request #12609).
[jan] Replace categories with tags (Request #9544).


------
v4.1.5
------

[mjr] Fix pagination of search results (Bug #13047).
[mjr] Don't output empty properties for CardDAV requests (Bug #12782).
[jan] Update Korean translation (Deokgon Kim <dgkim@dgkim.net>).
[jan] Fix portal serach block response when no contacts have been found
      (dulinux <lfbm.andamentos@gmail.com>, Bug #13044).


------
v4.1.4
------

[jan] Fix importing vCard fields with lowercase TYPE attributes (Bug #13006).
[jan] Store full name in Kolab contacts.
[jan] Fix distribution list support in Kolab driver (Bug #12450).


------
v4.1.3
------

[jan] SECURITY: Fix XSS vulnerabilities when deleting address books.
[jan] Fix exporting selected contacts (Bug #12759).
[mms] Improved UI when viewing search results from Advanced Search.
[mms] Remove features from UI when VFS is not available or disabled.
[mjr] Fix filtering Facebook driver results (Bug #12739).
[jan] Gracefully deal with columns removed from the backend.


------
v4.1.2
------

[jan] Fix fatal errors if DAV support is disabled (Bug #12481).
[mjr] Fix deleting multiple contacts via the API (Bug #12554).
[mjr] Fix issue generating contact hashes from EAS contacts that could prevent
      duplicate contact detection from working when certain properties have
      empty values (Bug #12506).


------
v4.1.1
------

[jan] Import and export UID vCard attributes (Bug #12427).
[mjr] Honor the 'browse' setting when attempting empty searches.
[jan] Set generic 'phone' attribute when importing from vCard (Bug #12329).
[mjr] Add API methods for using history modification sequences.


------
v4.1.0
------

[jan] Fix searching in LDAP address books (Bug #12297).


---------
v4.1.0RC1
---------

[mms] Back button in smartmobile view for group member returns to group entry,
      not browse list.
[mms] Fix resetting smartmobile entry page when viewing more than 1 contact.


-----------
v4.1.0beta2
-----------

[mjr] Update the default SQL schema.
[jan] Fix incorrect dependencies.


-----------
v4.1.0beta1
-----------

[jan] Add CardDAV server support.
[mjr] Update the default SQL source schema (Request #11993).
[mms] Add links to group members on smartmobile entry page.
[mms] Add group icon to group contacts in smartmobile browse view.
[jan] Allow to search all search fields at once in basic searching.


------
v4.0.4
------

[mms] SECURITY: Fix XSS vulnerability on smartmobile contacts details page
      (João Machado <geral@jpaulo.eu>).
[jan] Fix importing certain phone fields from vCard (Bug #12178).
[mjr] Fix issues with importing contacts via ActiveSync when no default_dir
      pref is set (Thomas Jarosch <thomas.jarosch@intra2net.com>, Bug #12188)
[mjr] Fix ActiveSync global address book searches when using LDAP as backend
      (Bug #12089).


------
v4.0.3
------

[jan] Update French translation (Paul De Vlieger
      <paul.de_vlieger@moniut.univ-bpclermont.fr>).
[jan] Fix emptying shared address books.
[jan] Fix importing of LDIF data (Bug #11972).


------
v4.0.2
------

[mjr] Avoid sending broken datetime values to ActiveSync.
[jan] Update Basque translation (Ibon Igartua <ibon.igartua@ehu.es>).
[jan] Update French translation (Laurent Foucher
      <laurent.foucher@iut-tlse3.fr>).
[jan] Mark Kolab folder as default when changing default address book
      preference.


------
v4.0.1
------

[jan] Add free-text country attributes and use them in default Kolab backend
      (Request #11692).
[gwr] Fix handling empty dates in the Kolab driver (Bug #11691).
[jan] Use encoded UIDs as IDs in Kolab driver.
[jan] Fix searching shares for duplicates.
[mjr] Fix calling decode_attribute hook when exporting to ActiveSync
      (kd@tu-cottbus.de, Bug #11678).
[jan] Update Slovak translation (Jozef Sudolský <jozef.sudolsky@elbia.sk>).


------
v4.0.0
------

[jan] Update Polish translation (Krzysztof Kozera <krzysztof113@o2.pl>).
[jan] Update Dutch translation (Arjen de Korte <arjen+horde@de-korte.org>).


---------
v4.0.0RC1
---------

[jan] Allow searching for 'emails' attributes (Bug #11185).
[jan] Fix LIKE matching of attributes in Kolab driver.
[mms] Convert turba minisearch block to the Horde AJAX framework.
[jan] Support 'emails' attribute in smartphone view (Bug #11544).
[jan] Attach share owner to all address book titles (Bug #11528).
[jan] Fix exporting from browse view (Bug #11526).
[jan] Return to the same page after running actions from the browse view.


-----------
v4.0.0beta3
-----------

[jan] Support importing contacts via API if using 'emails' attributes (Bug
      #8358).
[jan] Support 'emails' attribute with ActiveSync.
[jan] Fix marking contacts as deleted in the history if deleting shared address
      books (Bug #11480).
[jan] Set gender field values literally to 'male' or 'female'.
[jan] Drop preference which address books to display.
[gwr] Mark the initial default share as such with the Kolab backend.
[gwr] Always mark the initial share as default addressbook.
[mms] Initial implementation of smartmobile view.


-----------
v4.0.0beta2
-----------

[jan] Use Horde 5 action bar.


-----------
v4.0.0beta1
-----------

[jan] Add configuration example for Kolab/IMAP address books.
[jan] Update icon set.
[jan] Fix searching multiple names via the API.
[jan] Fix searching and listing clients via the API.


------------
v4.0.0alpha1
------------

First alpha release for Horde 5.
[mms] Import API call now throws an ObjectExists exception when a duplicate is
      found.
[jan] Add parameters to specify field size of phone and email fields.


-------
v3.0.15
-------

[jan] Fix sorting of columns in preferences (Bug #10795).
[jan] Remove user's address books when removing users, independent from address
      book permissions.
[mms] Fix infinite loop if array was passed to delete API call.
[mms] Fix descending sorting of result lists.
[mms] Return to same page when deleting contact from browse view.
[mjr] Add ability to return count of objects matching search in place of full
      result set.
[jan] Update Turkish translation (İstanbul Technical University).
[jan] Fix strict searching in favourites driver (Bug #11207).


-------
v3.0.14
-------

[jan] Update Swedish translation (Per Olof Ljungmark <peo@bsdlabs.com>).
[jan] Update Italian translation (Emilien <emilien@wifi.e4a.it>).
[jan] Fix number of contacts in a list that cannot be displayed.
[jan] Update Slovak translation (Marika Schvarczova
      <schvarczova.marika@domeny.sk>).
[jan] Update Czech translation (Michal Foist <michal@foist.cz>).


-------
v3.0.13
-------

[jan] Fix decode_attribute hook when exporting to vCard (kd@tu-cottbus.de, Bug
      #11123).
[jan] Update Hungarian translation (Zoltán Németh <nemeth.zoltan@etit.hu>).
[jan] Only connect to LDAP driver for read/write requests (Dominique Lalot
      <dom.lalot@gmail.com>, Request #11082).
[mjr] Fix bug that caused time shifting of contact birthday and anniversary
      values from ActiveSync devices for users in certain timezones.


-------
v3.0.12
-------

[mjr] Ensure contact lists are always populated with their members (Bug
      #10961).
[jan] Fix SyncML compatibility with work/home phone numbers and newer Funambol
      clients (Bug #10912).
[mjr] Implement more flexible ActiveSync synchronization of names and
      addresses.
[jan] Fix address book sorting in preferences (Bug #10897).
[mms] Improve navigation when editing group entries.


-------
v3.0.11
-------

[jan] Set VOICE parameter when exporting phone numbers to vCard (Request
      #10349).
[jan] Fix importing vCards with empty X-ANNIVERSARY attributes (Bug #10557).
[jan] Update Japanese translation (Hiromi Kimura <hiromi@tac.tsukuba.ac.jp>).


-------
v3.0.10
-------

[mjr] Add the ability to specify the fields to return from contacts/search.
[jan] Fix importing contacts with composite fields.
[jan] Fix LDAP connection test (Bug #10554).
[gwr] Avoid including the owner name into the default share (Kolab backend).


------
v3.0.9
------

[rla] Turba LDAP Driver now only rewrites changed attributes (Bug #9343).
[mjr] Run attribute values through decode_attribute hook when exporting.
[mjr] Ensure encode_attribute hook is called on imported objects.
[mjr] Improve handling of removeUserData.
[mjr] Honor auto_create configuration setting (qoole.horde@lillimoth.com, Bug
      #10452)
[jan] Don't allow to search binary fields.


------
v3.0.8
------

[jan] Fix attribute name for assistant phone (Bug #10449).


------
v3.0.7
------

[jan] Add missing migration script (Bug #10436).


------
v3.0.6
------

[mjr] Fix issue with synchronizing deleted contacts (Bug #10422).
[jan] Fix searching for duplicates on some databases (Bug #10383).
[mjr] Add and support more attributes by default.


------
v3.0.5
------

[mjr] Fix obtaining default share via Turba's API (vilius@lnk.lt, Bug #10393).
[mjr] Force ActiveSync device reset after sync_books pref is changed (Request
      #10342).


------
v3.0.4
------

[jan] Pass contact object to decode_attribute hook (kd@tu-cottbus.de, Bug
      #10287).
[jan] Complete fix for importing LDIF files (Bug #10139).


------
v3.0.3
------

[rla] Support multiple address books in search portal block (Request #8786).
[mjr] Fix importing LDIF files (Bug #10139).
[mjr] Fix issue introduced in 3.0.1 that caused contact images to not display
      (Bug #10050).
[jan] Fix editing of multiple contacts at once (Bug #10085).
[jan] Enable homeAdress and workAdress composite fields by default.


------
v3.0.2
------

[jan] Fix exporting department attribute over ActiveSync.
[mjr] Fix adding contacts with a category selected.


------
v3.0.1
------

[jan] Fix LDAP schema checking (Bug #9826).
[jan] Fix creating temporary files with open_basedir restrictions.
[mjr] Fix merging duplicate contacts (Bug #9828).
[mjr] Allow unsetting the GAL and Client Address Book settings (Bug #9843).
[mjr] Fix importing objects with categories (Bug #9841).


------
v3.0.0
------

First stable release for Horde 4.
[mjr] Fix deletion of virtual address books (Bug # 9779).
[jan] Fix saving searches to virtual address books (Bug #9776).
[mjr] Datatree share to SQL upgrade script refactored for Horde 4.
[jan] Move all executable scripts to bin/ and prefix with turba-.
[jan] Add fields to all addresses if multiple passed to addField() API method
      (Request #3482).


---------
v3.0.0RC2
---------

Second release candidate for Horde 4.
[mjr] Fix issue that caused the inability to preview contact images while
      uploading (Bug #9702).


---------
v3.0.0RC1
---------

First release candidate for Horde 4.
[gwr] Adapted the Kolab driver to Horde 4.
[mjr] Fix issue that caused erroneous file listings for objects in sources
      without a __uid value.
[cjh] Fix storing of binary fields.
[mjr] Fix/refactor IMSP driver.


-----------
v3.0.0beta1
-----------

[mjr] Fix the listTimeObjects API for shared sources (Bug #9649).
[jan] Fix importing contacts with SyncML (Simon Bühler, Bug #9641).


------------
v3.0.0alpha1
------------

First alpha release for Horde 4.
[jan] Provide default configuration files instead of .dist versions.
[jan] Create a default address book if the user doesn't own any yet.
[jan] Rename sources.php to backends.php.
[mjr] If default addressbook is not browsable, try one from the addressbook
      pref (Request: 6536).
[jan] Add duplicate search and merging.
[mjr] The listTimeObjects API now returns categories for each source
      individually instead of returning only the categories available (Request
      #8504).


------
v2.3.6
------

[mjr] Fix issue that caused erroneous file listings for objects in sources
      without a __uid value.
[jan] Allow to export photo/logo fields to vCard without MIME type.
[jan] Support X-EPOCSECONDNAME fields of Nokia phones.
[jan] Add upgrade scripts for next-generation SQL share driver.
[jan] Fix splitting up names when exporting to N properties of vCards.
[jan] Only set the encoding parameter for binary data in vCards, if data is not
      empty (Bug #9413).
[jan] Fix searching for fields matching an email address if using 'emails'
      attribute instead of 'email' (Bug #9472).
[jan] Use personal address books first if determining the default one (Valentin
      Vidic, Request #9367).
[jan] Use name format preference not only for paging, but for sorting too
      (Request #8806).
[jan] Fix photo corruption when exporting to vCard 3.0 (Bug #9100).


------
v2.3.5
------

[jan] Correctly export FN vCard property if 'alternative_name' is set, but not
      'name' (Bug #9207).
[jan] Fix import of addresses from LDIF (Axel Jurak, Bug #9215).
[jan] Speed up browsing of long address books.


------
v2.3.4
------

[jan] Remove deleted contacts from distribution lists in the same address book.
[mjr] Allow creation of default, personal address book when other read-only
      sources are present.
[mjr] Log in history when deleting all of a user's contacts (Bug #8755).
[jan] Only export non-empty fields if exporting manually.
[jan] Add export to vCard 3.0.
[jan] Only synchronize those fields that are supported by the client (Request
      #6658, requires Horde 3.3.7).


------
v2.3.3
------

[jan] Fix syntax of MSSQL scripts (Bug #8664).
[jan] Add preference for the name format to use for sorting (Request #6721).
[jan] Condense whitespace in composite fields (Request #8654).
[jan] Add and fix Oracle-specific SQL scripts.
[jan] Add Croatian translation (Matej Vela <matej.vela@carnet.hr>, Iva Rumora
      <iva.rumora@zg.t-com.hr>).
[mjr] Fix permission checking for virtual address books.
[jan] Update deleted attributes during synchronization (lst_hoe02@kwsoft.de,
      Request #6658).
[jan] Support X-ANNIVERSARY, X-CHILDREN, and X-SPOUSE vCard fields (Request
      #8074).
[jan] Fix copying and moving of image fields (Ryu <ryu@ryux.org>, Bug #8523).
[jan] Don't return an error on empty LDAP search results (Bug #8595).
[jan] Replace PHP5-only code from the LDIF exporter (Bug #8586).


------
v2.3.2
------

[mms] Upgrade prototype.js to v1.6.1.
[jan] Fix synchronization with output compression enabled (Bug #7769).
[mjr] Fix contacts being deleted during synchronization when moved from one
      address book to another (ryu@ryux.org, Bug #8487).
[mjr] Add new API method for retrieving the default share for a source.
[jan] Don't overwrite the compositing fields, when importing composite fields.
[cjh] Fix searches for multiple strict fields and at least one non-strict field
      (tinu@humbapa.ch, Bug #7876).
[mjr] Specific timeobject categories are now only advertised when they are
      present in a configured source.


------
v2.3.1
------

[jan] SECURITY: Escape output in test.php.
[jan] Add script to import contacts from SquirrelMail database.
[gwr] Correct support for the freebusy URL in Kolab.
[gwr] Add photo support for the Kolab driver.
[jan] Import broken vCards from Synthesis clients (Bug #7407).
[cjh] Add two retries to find a contact after adding it (Bug #7478).
[cjh] Add a PostgreSQL-specific upgrade script for 2.2.1 to 2.3
      (michael.menge@zdv.uni-tuebingen.de, Bug #7462).
[jan] Don't overwrite empty address books preference when creating new shares
      (Bug #7399).
[mms] Upgrade prototype.js to v1.6.0.3.


------
v2.3.0
------

[jan] Change group field in shares table to work with LDAP groups (Bug #6883).
[jan] Fix exporting address books with country fields as vCards (Bug #7372).
[mjr] Make sure we use all address books when searching via the api and the
      user's addressbooks pref is empty (Bug #7357).
[mjr] Correctly calculate the age of time objects (Bug #7330).


---------
v2.3.0RC1
---------

[jan] Improve vCard EMAIL field parsing (Bug #7281).
[jan] Correctly import and export address extensions (Bug #7279).
[jan] Export full country names to vCard addresses.
[jan] Respect precedence of multiple vCard properties (Request #7122).
[jan] Remove deleted address books from address book preference (Request
      #6938).
[jan] Export LABEL properties to vCard if address fields are available.
[gwr] Add support for storing public PGP keys when using Kolab.
[gwr] Add support for adding addresses from IMP when using Kolab.
[jan] Add configuration option for an alternative name field.
[jan] Add support for image fields to SQL driver (requires Horde 3.3).
[jan] Add more default field mappings for CSV import (Request #6901).
[jan] Update field names for Outlook 2003 export (Request #6901).
[jan] Improve logic which entries to show in the sidebar menu.
[jan] Add support for the category form field (Request #6884).
[jan] Fix sorting so that sort order is always reflected correctly, independent
      of name format.
[jan] Add Basque translation (Euskal Herriko Unibertsitatea EHU/UPV
      <xabier.arrieta@ehu.es>).
[jan] Add ability to mark a contact as your own and API method to export it.
[jan] Fix importing phone numbers from Synthesis clients (Bug #7011).
[mjr] Fix issue with searching composite fields when the number of search terms
      is less than the number of composed fields (Bug #6796)
[cjh] Allow importing multiple address into an email field if allow_multi is
      set to true on the field in attributes.php (Bug #6897).
[mjr] Remove user permissions on all shares when deleting a user.
[jan] Fix searching of client address books that have been disabled in the
      preferences (Bug #6961).
[mjr] Fix issue with removeUserData api that caused the deleted user's address
      books to not be deleted as well as remove an erroneous error notification
      (Bug #6969).
[cjh] Fix the column selector/sorter in IE (Bug #6912).


------
v2.2.2
------

[jan] SECURITY: Escape output in test.php.


------
v2.2.1
------

[cjh] SECURITY: Escape contact names in the contact display view.
[jan] Fix importing of certain phone numbers from vCard (Bug #6744).
[mjr] Correct a function declaration in the 2.1_to_2.2_sql_schema.php upgrade
      script that was causing fatal errors.


------
v2.2.0
------

[mjr] Fix importing email addresses from CSV files to be consistent with what
      we allow to be entered via the UI. (Bug #6725)
[cjh] Improve resource usage in datatree_to_sql share migration script (Bug
      #6740).


---------
v2.2.0RC4
---------

[cjh] Fix editing contacts that were accessed by UID (Bug #6672).
[cjh] Apply fix for http://dev.rubyonrails.org/ticket/11473 to prototype.js
      (Request #6590).
[cjh] Add an upgrade script for the new SQL share driver (Request #6109).
[cjh] Include composite fields in data exports (Bug #6517).
[gwr] Add distribution list support to the Kolab driver.
[cjh] Add vCard/syncing support for a large number of additional attributes
      (horde@ssn.at, Request #6573).
[cjh] Update composite fields in LDAP DNs (horde@ssn.at, Bug #6575).
[mjr] Fix paging in search results.
[cjh] Allow setting default values for attributes.
[cjh] Show a browse link in the address book list for each address book
      (thomas.jarosch@intra2net.com, Request #6613).
[mjr] Fixed a bug that caused field values to get mismatched with the column
      names when a single DB field is mapped to multiple Turba fields.
[mjr] Fix changing sort order on the search view.
[jan] Add preference to choose address books for synchronization.
[jan] Improved importing of names from vCards (Bug #6568).
[jan] Fix incomplete copying and moving of attributes to composite fields (Bug
      #6565).
[gwr] Fix the relation of key/uid within the Kolab driver.
[gwr] Export/import of the emails attribute (Bug #6504).
[mas] Encode DN correctly when exporting to LDIF. (Bug #6518).
[gwr] Fix virtual address books when using shares.
[gwr] Fix searching for the Kolab driver.
[cjh] Replace the address book column sorter with a Scriptaculous-based one;
      fixes re-ordering columns in some cases (Bug #6444).
[jan] Always return to the last view after saving a contact.
[jan] Correctly determine default address books in the API (SyncML, WebDAV).
[jan] Add categories imported through the API (SyncML, WebDAV).
[jan] Store categories as strings.
[cjh] Show who created or made the last change to a contact along with the date
      (Request #6305).
[mjr] Prevent overwriting contact entries with the upgrade script (Bug #6308).


---------
v2.2.0RC3
---------

[cjh] SECURITY: Fix unchecked access to contacts in the same SQL table (Bug
      #6208) (CVE-2008-0807).
[jan] Add configuration to more flexibly parse full names into the name parts.


---------
v2.2.0RC2
---------

[jan] SECURITY: Fix privilege escalation in Horde API.
[mjr] Degrade gracefully when no VFS is configured.
[cjh] Fixed the share flattening upgrade script.
[mjr] Fixed issue that caused mangling of composite fields when moving or
      copying contacts from one address book to another (Bug #6058).
[mjr] Fixed issue that caused listTimeObjects to only return objects from a
      single address book when using a shared SQL source.
[cjh] Update address book management UI to match other groupware apps.
[jan] Trim composite field values before saving to the backend (Bug #5979).
[mjr] Fixed issue where composite fields with 'attribute' value set were not
      getting set in the backend when being imported via the API. (Bug #5978)
[mjr] Time object categories are now automatically detected.
[mjr] Fix issue that caused listTimeObjects API to miss returning objects when
      the date range crosses over into the next year.
[jan] Improved portability of the upgrade script (Bug #5949).
[mjr] Added anniversary support to the listTimeObjects API.


---------
v2.2.0RC1
---------

[jan] Fix birthday calculation on years before 1970 with DST (Bug #5791).
[jan] Implement WebDAV DELETE.
[jan] Change default SQL scheme to match with RFC 2426 (vCard 3.0) as closely
      as possible.
[cjh] Add $matchBegin to the clientSearch API method (duck@obala.net, Request
      #5860).
[cjh] Avoid variable names that might interfere with function variables in
      sources.php.dist examples (Bug #5840).
[jan] Add clientFields() API method.
[mjr] More efficient fetching of entries when using the listTimeObjects API.
[jan] Move all Turba-specific hook examples from Horde's config/ directory.
[cjh] Fix generation of UIDs with PHP 5.2+.
[cjh] Handle categories when converting to and from vCards
      (rsalmon@mbpgroup.com, Bug #5648).
[cjh] Catch searches that seem non-empty but really aren't (Bug #5612).
[mjr] Fix fatal errors when no share enabled sources are present.
[mjr] Fix issue with naming new contact lists that was causing database errors,
      missing part of the contact list name, and other oddities.


-----------
v2.2.0alpha
-----------

[cjh] Add support for approximate searches, if the underlying backend and Horde
      code support them (Request #2901).
[cjh] Add a print link for contacts (Request #2800).
[cjh] Shared Address Books are now stored in a flat namespace so that they do
      not rely on the hierarchical (i.e. DataTree) properties of the
      Horde_Share API (Bug #4960).
[cjh] If names are displayed "Lastname, Firstname", sort composite name fields
      by lastname (Request #3909).
[cjh] Show an overlay while running a search (Request #3154).
[cjh] Add Anniversary, Spouse, and Children fields and support them in vCard
      import/export (ntai@smartfruit.com, Request #5059).
[cjh] Add LDIF import/export support (ritaselsky@gmail.com, Request #2506).
[jan] Provide birthdays as events to external calendars (Request #723).
[mjr] Add driver to create address books from current user's Horde_Group
      memberships.
[jan] Allow to search through API for matches at word boundaries only (requires
      Horde 3.2).
[cjh] Phase out old ObjectView class in favor of proper forms in lib/Forms and
      views in lib/Views.
[cjh] Support for dereferencing LDAP aliases (aubert@femto-st.fr, Request
      #4532).
[mas] Conform to WCAG 1.0 Priority 2/Section 508 accessibility guidelines.
      (Request #4080)
[cjh] Support vCard initials and salutation fields if present in the Turba
      backend (s.heuer@hicom.de, Request #4248).
[cjh] Don't show empty tabs if a contact does not have a full name (Bug #4243).
[mjr] Add support for removing user data from backend storage when user is
      removed from Horde.
[jmf] Sort listings on multiple columns.
[cjh] Show numeric and alpha pagers at the top of listings, not the bottom
      (Bug #1312).
[jan] Add multidomain support for Kolab servers (tokoe@kde.org, Request #3579).
[jan] Use the same rendering code for contact details in the list views like in
      the contact views.
[jan] Allow editing of composite fields (horde@olen.net,
      rkean@keanconsulting.com, Request #2529).
[mjr] IMSP driver now has Horde_Share support.
[cjh] Add dynamic filtering of lists of contacts.
[mdj] Add support for split read/write database.
[mdj] Add failover support for SQL backend.
[mjr] Add virtual address book support.
[jan] Add driver to list most favourite recipients.


------
v2.1.7
------

[cjh] SECURITY: Fix unchecked access to contacts in the same SQL table (Bug
      #6208) (CVE-2008-0807).


------
v2.1.6
------

[jan] SECURITY: Fix privilege escalation in Horde API.


------
v2.1.5
------

[mjr] Fix some fatal errors caused by the IMSP driver when deleting certain
      contacts and while adding contacts to lists in certain cases.
[mjr] Fix adding contacts to a new contact list in a source other than the
      source the contacts being added are from.
[jan] Fix paging through search results from another than the default address
      book (Bug #5137).
[cjh] Fix copy/moving contacts to a new contact list (Bug #5144).


------
v2.1.4
------

[jan] Fix character set encoding of exported vCards.
[mjr] Fix fatal error when exporting to vCard.
[cjh] Organize basic search form from left to right (Request #4914).
[jan] Fix links to only show contacts or lists, or both.
[mjr] Don't remember the lastly selected address book in the session, if it was
      not browseable.
[mjr] Fix bug that caused counting the number of contacts in a shared SQL
      source to return the count of the user's default address book instead.
[mjr] Fix bug that caused the wrong address book to be deleted when replacing
      an address book during import.


------
v2.1.3
------

[jan] Support departments in vCard's ORG properties (martin@matuska.org,
      Request #4285).
[cjh] Fix LDAP driver check for whether objects need to be renamed (Bug #4468).
[jan] Fix generation of mailto: links if IMP is not installed (Bug #4334).
[jan] Show error message if imported file didn't contain contacts (Bug #4260).
[jan] Remember the lastly selected address book during the session.
[jan] Add categories from imported contacts to the user's categories.


------
v2.1.2
------

[mjr] Fix addressbook.php script - don't attempt to submit the form with
      invalid addressbook selections.
[cjh] Add documentation for the filter parameter in sources.php.dist and an
      example for retrieving data from two different tables (Manilal K M
      <manilal.krishnapillai@ejyothi.com>).
[cjh] Centralize code for building RDNs (Request #3966).
[cjh] Pass objects by reference to hooks so modifications can stick (Bug
      #3957).
[jan] Fix compose links in portal if using compose popups in IMP (Bug #3923).


------
v2.1.1
------

[cjh] Be consistent in working with lowercase attribute names for the LDAP
      driver (Bug #2440).
[mjr] Fix create_default_histories.php and public_to_horde_share.php scripts to
      prevent creation of bogus shares.
[mjr] Fix create_default_histories.php script to work with shared sources.
[jan] Add 1.2 to 2.x upgrade script for Oracle.
[jan] Fix script to create default histories, necessary for synchronization.
[jan] Fix loading of CLI library in the public_to_horde_share.php script.
[mjr] Fix losing session when editing address books with disabled cookies.
[cjh] Show the copy/move dropdown any time there is an editable address book
      that's not the current one (Bug #3588).
[jan] Don't show warning after dealing with contacts from a non-browseable
      address book (Bug #3587).
[jan] Fix configuration example for birthday fields.


------
v2.1.0
------

[ben] Better support for MS-SQL


---------
v2.1.0RC1
---------

[mjr] Default to showing the 'A' page when browsing address books that contain
      more than the 'perpage' number of entries.
[jan] Add Icelandic translation (Bjorn Davidsson <bjossi@snerpa.is>).
[mjr] Fix paging when viewing search results.
[mjr] Only show actions that make sense for the current source.
[mjr] All IMSP address books, including dynamically configured sources are now
      uniquely identified across all users internally.
[jan] Reverse sorting order if clicking on column name (t.zell@gmx.de, Request
      #2484).
[jan] Add option to keep name field unformatted (m.zdila@episoftware.com,
      Request #2441).
[mas] Use summary notifications for contact changes instead of one notice for
      each change. (Bug #2764)
[jan] Add CLI script to import vCard data.
[cjh] Split checking of LDAP field syntax and checking of required fields
      (tevans@tachometry.com, Bug #2626).
[mjr] Horde_Share support added. SQL Driver only for now.
[cjh] Update objectclasses when saving LDAP entries created by other clients
      (m.zdila@episoftware.com, Bug #2405).
[cjh] Charset-aware handling of LDAP DNs (Bug #2395).
[cjh] Get rid of cached search results entirely, and move more display code
      into Turba_ListView, simplifying a number of different codepaths and
      avoiding servercide when using Advanced Search.
[mjr] Turba_Object and Turba_Driver objects are now responsible for checking
      permissions for the sources they represent.  This allows concrete
      Turba_Driver objects to override Horde Perms and perform their own
      permission checking (by checking ACLs for example).
[cjh] "readonly" and "admin" source hash entries are deprecated. Permissons are
      set through the Horde Perms UI now.
[cjh] Avoid adding exact duplicates during import (kevin_myer@iu13.org, Bug
      #1892).
[cjh] Honor the delete confirmation preference when displaying a contact (Bug
      #1315).
[cjh] If the comments API is available, comments can be attached to contacts
      (Request #1492).
[cjh] Users can select which address books they wish to use, and in which order
      they will be displayed (Request #1650).
[cjh] Contacts can now be added to lists stored in any address book (Request
      #1561).
[cjh] Introduce a "browse" setting on sources, seperate from the "export"
      setting, to allow differentiation of browseable and exportable sources.
[jan] Add permissions to restrict number of contacts per address book.
[cjh] Add exporting of multiple vCards in one file through the export interface
      (Frank Rosquin <frank.rosquin@gmail.com>).
[mjr] Added support for adding and deleting IMSP addressbooks via the options
      interface (Request #1578)
[mjr] Show previous search results whenever returning to the search page.
[cjh] Handle encoding of postalAddress fields to use $ for newlines, going
      either by attributes.php or by the LDAP schema itself (Edward Rudd
      <eddie@omegaware.com>, Request #2).
[mjr] Search terms on composite fields are now taken as a space delimited list
      of strings that are each OR'd against each field making up the composite
      field  and then cumulatively AND'd together.
[jan] Show warnings from CSV imports.
[jan] Add "Add" and "Search" entries to sidebar menu.
[jan] Return to original browse view after finishing group editing.
[jan] Add submenu with address books to sidebar.
[jan] Allow to specify charset of imported CSV files.
[cjh] Pass the Turba_AbstractObject to attribute hooks to allow access to other
      attribute values (for example, to build a field's value out of other
      fields).
[jan] Show list of edited contacts below edit form when editing several
      contacts at once.
[jan] Add VFS support to attach files to contacts.
[jan] Allow to edit several contacts at once.
[jan] Retrieve only required fields from backend.


------
v2.0.5
------

[cjh] Close several XSS vulnerabilities with address book and contact data.


------
v2.0.4
------

[jan] Fix source selection in some API methods (tevans@tachometry.com, Bug
      #2623).
[jan] Fix warnings in columns preference screen.
[mjr] Check for global IMSP configuration and use if present.
[mas] Restore BC in searching using SQL driver. (Bug #2419)


------
v2.0.3
------

[jan] Add Turkish translation (Servet Güney <sguney@metu.edu.tr>, Ahmet Öztürk
      <oahmet@metu.edu.tr>).


---------
v2.0.3RC1
---------

[jan] Don't show "Add" icon if no writeable address books exist.
[jan] Don't show "Browse" icon and list if no browseable address books exist.
[jan] Add example how to use a field for Horde's category system.
[cjh] Allow uid to be used in key generation (especially useful for LDAP
      backends that want to use uid in the DN) (Bug #2027).
[mjr] Fix bug where search results are not displayed when no browseable
      addressbooks exist and bug where the browse attribute is ignored for
      addressbooks that are set as default, allowing a non-browseable
      addressbook to be browsed (Bug #1959).
[jan] Import and export of birthdays with vCards (thomas@gelf.net, Bug #1269).
[jan] Fix mini search portal block with non-ascii search strings (Bug #1605).
[cjh] Add a generic SQL upgrade script, replacing the MySQL-specific version
      (Bug #1781).
[mjr] Use addressbook name as part of cache key to prevent breaking similar
      searches on different IMSP addressbooks.
[cjh] Use bind variables in the SQL driver (selsky@columbia.edu, Bug #1651).
[mjr] Fix API search() method to correctly deal with contacts containing
      multiple email-type fields (Bug #1284).
[cjh] Fix _read() for multiple objects in the LDAP driver (Bug #1520).
[mjr] Cache IMSP search results when sending multiple IMSP searchaddress
      commands for the same search.
[cjh] Show actions at the top and bottom of contact listings (Bug #1458).
[jan] Add shortcut icon (favicon.ico).
[mjr] Show Contacts and Show Groups links now work correctly with IMSP driver.
[jan] Don't include names in email fields of distribution lists retrieved
      through the "search" API method (Bug #1384).


------
v2.0.2
------

[jan] Fixed warning in browse view (Bug #1363).


------
v2.0.1
------

[jan] Fixed some javascript errors when clicking on the column headers to
      resort contact listings (Bug #1313).
[cjh] Quote LDAP DN entries according to RFC 1485 (Bug #1146).
[cjh] When importing vCard 3.0 ADR fields, try to build a composite entry for
      workAddress or homeAddress, and keep the street address in workStreet or
      homeStreet (Bug #1109).
[jan] Implement OR searches in IMSP driver (Michael Rubinsky
      <mike@theupstairsroom.com>, Bug #1256).


---------
v2.0.1RC1
---------

[jan] Create compose links for all email addresses at once in contact listings
      (requires IMP 4.0.2).
[jan] Open compose windows from the portal's minisearch block in the correct
      frame (Bug #1293).
[jan] Several performance optimizations.
[jan] Don't return empty result sets in search API (Bug #1210).
[cjh] Support TLS connections to LDAP servers (Bug #1149).


------
v2.0.0
------

[cjh] UIDs need to be stored in the History system with a turba: prefix and
      with the contact owner so as not to confuse different instances of the
      same contact (if two users both have a contact in their seperate
      addressbooks in a private source, they should have unique histories for
      those contacts).
[cjh] Improve error and permission checking.


---------
v2.0.0RC3
---------

[cjh] Prevent copying/moving of groups (Bug #935).
[cjh] Fix IMSP groups (Michael Rubinsky <mike@theupstairsroom.com>)
[jan] Fix propagating of monthdayyear fields (Bug #920).
[jan] Fix SOAP namespace for API method signatures.
[cjh] Change to Turba::getMenu(), fixes the menu on the Options screen (Bug
      #898).
[jan] Fix some javascript errors with IE 5.0.


---------
v2.0.0RC2
---------

[cjh] Don't overwrite form data with object defaults when editing if validation
      fails (Bug #883).
[cjh] Use source permissions if they are present, and if not, fall back to the
      old source admin array (Bug #853).
[cjh] Ignore any __-prefixed attribute in building search criteria (Bug #877).


---------
v2.0.0RC1
---------

[mms] Fixed the delete API to not exit with error if the item to be deleted is
      not found in the first source provided.
[cjh] Removed miniwindow.php; it simply provided a frame around Turba with a
      close button.


----------
v2.0.0beta
----------

[jan] Allow to group fields into tabs.
[mms] Link email address in object view.
[cjh] Merge the code for Turba_Source and Turba_Driver into simply
      Turba_Driver.
[jan] Add Persian (Western) translation (Vahid Ghafarpour
      <vahid@ghafarpour.com>).
[jan] Add configuration option to require certain fields in the LDAP driver.
      (Tarjei Huse <tarjei+a_lists.phpgw@nu.no>).
[cjh] Support custom field mappings in CSV exports, and add an Outlook export
      type.
[cjh] Allow replacing your addressbook with an imported one (Francois Marier
      <francois@nit.ca>).
[cjh] Don't show source selection dropdowns in cases where there would only be
      one choice (Francois Marier <francois@nit.ca>).
[cjh] Turba's API has been consolidated somewhat, with a unified import method
      replacing add, addContact, and import_vcard.
[jan] Add access keys.
[cjh] Add Kolab drivers (Stuart Bing� <s.binge@codefusion.co.za>).
[cjh] The alphabetic pager now has an "All" option.


-----------
v2.0.0alpha
-----------

[cjh] Show an alphabetic pager for browsing address books (Mike Bydalek
      <mbydalek@zivix.com>).
[cjh] Rename LDAP objects when their DN changes (Tarjei Huse
      <tarjei+a_lists.phpgw@nu.no>).
[cjh] Add exporting of VCards from the browse/search view (Mike Bydalek
      <mbydalek@zivix.com>).
[cjh] Initial IMSP driver (Michael Rubinsky <mike@theupstairsroom.com>).
[cjh] Use Horde_UI_Pager to page browse results (Joel Vandal
      <joel@scopserv.com>).
[cjh] Basic support for setting permissions on Turba sources (Joel Vandal
      <joel@scopserv.com>).
[cjh] Unify search and advanced search code to use a much more similar
      interface (Joel Vandal <joel@scopserv.com>).
[cjh] Javascript delete confirmation is now available as a preference ("W.
      David Betts" <david@populus.com>).
[cjh] Searching composite fields, and other complex generated searching, now
      works with the LDAP driver.
[cjh] Track addition, modification, and deletion of contacts with the Horde
      History:: API.
[cjh] Use arbitrary search support to include searching of composite fields.
[cjh] Turba_Drivers are now capable of arbitrary searches, including unlimited
      nested combinations of AND and OR searches.
[cjh] Add the ability to link fields in the backend into a composite field,
      which is not editable, but which displays the correct value.
[cjh] Add the ability to move or copy contacts to a separate addressbook.
[cjh] Display multiple email addresses more intelligently (John Dalbec
      <jpdalbec@ysu.edu>).
[cjh] Allow setting a limit on the number of queries returned by an LDAP search
      (Andrew Morgan <morgan@orst.edu>).
[cjh] Add edit/delete links in browse views.
[cjh] Preference for default directory for searches, etc. (Richard Heggs
      <Richard.Heggs@nottinghamcity.gov.uk>).
[mms] Add support for listing/adding/retrieval of public keys.
[cjh] Use the new PrefsUI class.
[jon] Adapt to the new Horde::img() syntax.
[cjh] Use the new Notification system.
[jan] Remove the standard value for the language preference. The language to
      fall back to should be set Horde wide in lang.php instead.


------
v1.2.5
------

[jan] Close XSS when setting the parent frame's page title by javascript (cjh).
[jan] Fix warning with LDAP backends.


------
v1.2.4
------

[jan] Fix distribution lists.


------
v1.2.3
------

[cjh] Check permission when adding and deleting objects (Bug #671).
[jan] Fix bug in LDAP driver with dn values not being UTF8 encoded (Bug #378).
[jan] Fix sorting by columns in browse view.
[cjh] Use prepare/execute in the SQL driver to support large fields on Oracle
      and other databases (Matt Selsky <selsky@columbia.edu>).
[jan] Don't create distribution list if process gets cancelled (Bug #377).


------
v1.2.2
------

[jan] Add Galician translation (Rafael Varela Pet <srrafa@usc.es>, Guillermo
      Mendez <guille@usc.es>).


------
v1.2.1
------

[jan] Fix importing of vCard 2.1 data that contains commas (needs Horde 2.2.4).
[jan] Make sorting order dependent of the name format (Sergey Zhukov
      <sergey@intellij.net>).
[jan] Add Arabic (Syria) translation (Platinum Development Team
      <devteam@platinum-sy.net>).
[jan] Add Macedonian translation (Stojan Pesov <ssp@eureka.com.mk>).
[jan] Add Romanian translation (Eugen Hoanca <eugenh@urban-grafx.ro>, Marius
      Dragulescu <mariusd@urban-grafx.ro>).
[cjh] Remove dependency on class not in Horde 2.x.


------
v1.2.0
------

[cjh] Use the 'objectclass' entry from LDAP sources instead of defaulting to
      'objectclass=*'.
[jan] Add Catalan translation (Angels Guimer� <angels.Guimera@uab.es>).
[jan] Add a preference for viewing names as Lastname, Firstname (Marc Jauvin
      <marc@register4less.com>).
[jan] Add Latvian translation (Kaspars Kapenieks <kaspars@rcc.lv>).
[cjh] Close several small XSS vulnerabilities (Mitja Kolsek
      <mitja.kolsek@acros.si>).
[cjh] Fix problems with cached search results from different backends.
[jan] If an LDAP directory is configured to use utf8 encoding, encode
      attributes when adding them to the directory (cjh).
[jan] Add Turba_List::remove() (cjh).
[jan] Add Turba_Object::fromvCard() (cjh).
[jan] Add a registry script for Turba (Michael Cochrane
      <mike@graftonhall.co.nz>).
[jan] Add distribution list support (Michael Cochrane
      <mike@graftonhall.co.nz>).
[jan] Add personal LDAP address book HOWTO and example (cjh).
[jan] Add generic add, delete, get, list API functions for specific fields
      (mms).
[jan] Add Turba::addParameter().
[jan] Add Lithuanian translation (Darius Matuliauskas <darius@lnk.lt>).
[cjh] Add a miniwindow interface that can be used in popups from other
      applications.
[cjh] Add preferences-based addressbook capability for small, private
      addressbooks.
[cjh] Make sure vCard email addresses are imported as just the email address,
      not as Personal Info <address@example.com>.
[cjh] Add Turba::getBareAddress() for converting "Personal Info
      <address@example.com>" into just address@example.com.
[jan] Add Bulgarian translation (Miroslav Pendev <pendev@hotmail.com>).
[cjh] Add links to MapQuest from address fields.
[jan] Pass contact name to compose link in display view.
[jan] Replace <?= with <?php echo to remove the short_open_tags requirement
      (cjh).
[jan] Fix preference for default view.
[jan] Add import/export filter for TSV, Mulberry and Pine (Liam Hoekenga
      <liamr@umich.edu>).


------
v1.1.0
------

[jan] Add Hungarian translation (Laszlo L. Tornoci <torlasz@xenia.sote.hu>).
[jan] Add Norwegian Nynorsk translation (Per-Stian Vatne <psv@orsta.org>).
[jan] Add Slovenian translation (Jure Krasovic <jurek@rcc-irc.si>).
[jan] Add Japanese translation (B.J. Black <william.black@sun.com>).
[cjh] Add an optional parameter to set the LDAP protocol version.
[cjh] Close a potential problem with register_globals On and $js_onLoad.
[jan] Add Portugal Portugues translation (Nuno Loureiro <nuno@eth.pt>).
[cjh] Add a Browse interface for easily listing all contacts.
[cjh] Change some button inputs to submits and remove some javascript.
[cjh] Source-wide filters with LDAP are always AND-ed.
[cjh] Remove awkward To:, Cc:, Bcc: message composition interface and clean up
      UI.
[cjh] Delete empty attributes instead of just leaving them unchanged.
[cjh] Log SQL and LDAP queries at LOG_DEBUG.
[cjh] Don't generate LDAP searches with 'attr=**' in them for empty values
      (use attr=*).
[cjh] Say "Edit 'entry'" instead of just "entry" in the mouseover text for
      search results which are editable.
[cjh] Add a local LDAP directory example.
[cjh] Don't store objects in the search results session cache; a bit slower,
      but seems to be much more reliable.
[cjh] Vastly improve search results handling - store them in the session, don't
      add duplicate results, let people use the back button, etc.
[cjh] Fix the column select javascript.
[cjh] Add list mouseover effect (Ronnie Garcia <ronnie@mk2.net>).
[cjh] Fix results problem with advanced.php and old results.
[cjh] Patches to tweak the LDAP driver to handle things a bit more correctly
      (HiCkS <hicks@666.hn.org>).
[cjh] Add and use TURBA_TEMPLATES constant.
[cjh] Use $registry->get() for all Registry information.
[jan] Add 'admin' entry to the sources hash to give write access on readonly
      addressbooks to certain logged in users.
[jon] Enable the "portability" option in the SQL driver.
[jan] Add preferences page and user preference to select the columns that shall
      be displayed in the search results.
[jan] Add Estonian translation (Toomas Aas <toomas.aas@raad.tartu.ee>).
[jan] Add Slovak translation (Leo Mrafko <leo@oel.sk>).
[jon] Enable the "portability" option in the SQL driver.
[jan] Add Ukrainian translation (Andriy Kopystyansky <anri@polynet.lviv.ua>).
[jan] Add Danish translation (Martin List-Petersen <martin@list-petersen.dk>).
[jan] Fix bug "This person is already in your addressbook.".


------
v1.0.0
------

[jan] Add Norwegian Bookmal translation (Oystein Steimler <oystein@rexta.net>).
[avsm] Add .htaccess files to deny access to data directories.
[jan] Add Finnish translation (Leena Heino <liinu@uta.fi>).
[cjh] Avoid adding duplicate entries through the add API method.


---------
v1.0.0RC4
---------

[rich] Include rewritten and reorganized documentation.
[rich] License under Horde APL.
[cjh] Make email addresses clickable in displayed objects.
[bjn] Change 'en' and 'en_EN' locales to 'en_US' (default).
[cjh] Vastly improve error reporting when adding an object fails.
[jan] Add Brazilian Portuguese translation (Carlos Daniel Kibrit
      <kibrit@terra.com.br>).
[jan] Add Greek translation (Stefanos I. Dimitriou <sdimitri@teiath.gr>).
[jan] Add Swedish translation (Andreas Dahl�n <andreas@dahlen.ws>).
[jan] Add Korean translation (J.I Kim <aporie@netian.com>).
[cjh] Remove duplicate entries from multiple sources from
      turbaExpandAddresses() results.
[cjh] Don't show the addressbook select widget on the search page if there's
      just one to search from.


------
v0.0.3
------

[cjh] Add an optional 'strict' configuration array definining fields which must
      always be matched exactly.
[jan] Add API function to get info about the fields.
[jan] Add source configuration to select which fields should be searchable by
      default.
[cjh] Allow OR searches.
[cjh] Pass full email addresses (with names) to messages being composed (Lars
      Nummedal <largs@nummedal.net>).
[jan] Add Polish translation.
[jan] Add mapping of date/time fields to the import feature.
[jan] Add support for date fields (e.g. birthdays).
[jan] turbaExpandAddresses() now returns all email addresses that belong to a
      contact.
[jan] Show the fields in edit and display view dynamically based on what's
      provided by the backend.
[jan] Add Italian translation (Giovanni Meneghetti <gmeneghetti@infvic.it>).
[jan] Add import/export ui based on the new Data class.
[cjh] Add Traditional Chinese translation (David Chang <david@thbuo.gov.tw>).
[cjh] Add Czech translation (pchytil@asp.ogi.edu).
[cjh] Add Russian translation (Ignat Ikryanov <ignat@ibd.ru>).
[cjh] Add $conf['menu']['apps'] support and a help link.
[cjh] Make incremental building up of search results works again in both search
      and advanced search.
[cjh] Add Alias to default fields (Marc Jauvin <marc@register4less.com>).
[cjh] Use the *url() functions more consistently to make sure that cookie-less
      sessions work.


------
v0.0.2
------

[cjh] Add some more error checking to the searching and LDAP driver.
[cjh] Add config/attributes.php to provide nice labels for directory
      attributes.
[cjh] Adding German translation from Jan Schneider <janmailing@gmx.de>.
[cjh] Allow LDAP Sources to define a filter always included in searches
      (rbarnett@neuromics.com).
[jon] Preserve the search parameters after a search is performed.
[jon] Allow the registry to handle Turba's configuration values.
[jon] HORDE_BASE is now defined in lib/base.php instead of config/conf.php.
[max] Adding source retrieval API function.
[cjh] Adding Dutch translation from Jan Kuipers <jrkuipers@lauwerscollege.nl>.
[jon] Adding French translation from Sam Przyswa <samp@arial-concept.com>.
[cjh] Add gettext infrastructure.
[cjh] Define the HORDE_BASE constant in config/conf.php, and use it when
      referring to any of Horde's files.
[cjh] Bring the advanced search page up to date, and add it to the menu.
[jon] Retired config/menu.txt in favor of config/menu.php.  This file follows a
      new format based on native PHP data structures.
[max] Expand API to allow adding addresses to an addressbook.
[cjh] Add the first API function (expanding addresses) for Turba in
      lib/api.php.
[cjh] Add and Delete now work for the LDAP driver.
[cjh] Fix wap contacts searching.
[cjh] Turba now uses Horde authentication instead of its own. This means that
      whatever auth method you are using for Horde will be used to authenticate
      to Turba, and in return you get single sign-on with any other apps using
      Horde authentication.
[cjh] Working addObject() and removeObject() SQL driver methods.
[cjh] Move Turba_Source::getMyObject() to Turba_Source::getObject(); nothing
      was using the old getObject() call anymore.
[cjh] If you set $params['bind_dn'] and $params['bind_password'] for an LDAP
      source, Turba will bind as the specified dn to the LDAP server, letting
      you add/edit entries.
[cjh] Update capatilization to match Horde/PEAR standards.
[cjh] register_globals = Off fixes.
[cmc] Add a display object page, fix a ldap bug with the dn, add a read
      function to the turba source class (Done by Christian M. Couder (cmc)
      <christian@alcove.fr>).
[cjh] Add an advanced search page contributed by Christian Couder
      <christian@alcove.fr>.
[cjh] Bring the WML templates up to date with recent changes.
[cjh] Make the LDAP server port configurable and make sure the parameter
      appears in the example sources.
[cjh] Implemented edit functionality for the SQL driver.
[cjh] Moved the filter() functionality (and supporting functions) into
      Turba_List, where it really belongs.
[cjh] We now actually use Turba_List, Turba_AbstractObject, Turba_ListView, and
      many other pieces of the class hierarchy that were previously only
      referenced in the object model.
[cjh] Clean up the sql Driver implementation a bit. Now, if the source is
      private, the __owner criteria must match the current user, instead of
      using __key. __key should uniquely identify each object, and shouldn't be
      what user that object belongs to.
[cjh] Reorganize the class hierarchy a bit - use Object instead of Contact, and
      a few other naming changes.
[cjh] Merged WAP functionality into search.php. If a WAP browser is detected, a
      slimmed-down wml interface will be used that only displays names and
      (callable) phone numbers.


------
v0.0.1
------

[cjh] Fix bug where searches with no results would tack on an empty row.
[cjh] Conversion to CSS.
[cjh] Cleanup, modernization.
[jon] Silence session_start warnings.
[jon] Use Horde::url() in place of the deprecated buildURL() function.
[cjh] Use new session model and $horde['session_name'].
[cjh] Fixed message sending javascript to work with multiple addresses.
[jon] Allow directory sources to be set 'read-only' (non-editable).
[jon] Added a 'public' flag to the $cfgSources entries.
[jon] Contact attributes are configurable via config/attributes.php.
[jon] Renamed the source configuration hash to $cfgSources (from just
      $sources).
[jon] Moved from config/ldap.php to config/sources.php.
[jon] Converted Chuck's existing class stubs into a PEAR-style lib/ tree.
